// Particle-IK.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "MouseView.h"

#define PARTICLE_NUM 21

// ^Cg
char TitleString[] = "Particle-IK";

// _W
GLfloat eye[]={ 0.0, 0.0, 15.0 };
GLfloat center[] = { 0.0, 0.0, 0.0 };

GLfloat floorY = -5.0f;

GLdouble model[16], proj[16];
GLint view[4];
int windowWidth = 640;
int windowHeight = 480;
const GLfloat fovy = 60.0;
const GLfloat zNear = 1.0;
const GLfloat zFar = 100.0;

// }EXp
double oldPos[3], startPos[3], nowPos[3];
BOOL onButton[3];
int selectNo = -1;

CMouseView mv;

// p[eBNf[^
struct particleData
{
    // p[eBNԍ
    int no;
    // ڑĂp[eBN̔ԍ
    int back_no;
    int next_no;
    // ʒu
    double pos[3];
    // 1Öʒu
    double oldPos[3];
    // x
    double vel[3];
    // p[eBNԂ̏
    double back_distance;
    double next_distance;
    // p[eBN̔a
    double radius;
};

static particleData particle[PARTICLE_NUM];

// }EXNbNWp
GLfloat **vertexPos = NULL;

// 
void compute(void)
{
    double distance[3];
    int next, back;

    // ̌vZ
    for(int i=0; i<PARTICLE_NUM; i++)
    {
        particle[i].no = i;
        // ̐ڑ
        if (i == 0)
        {
            particle[i].back_no = -1;
        }
        else
        {
            particle[i].back_no = i-1;
        }
        // E̐ڑ
        if (i == PARTICLE_NUM-1)
        {
            particle[i].next_no = -1;
        }
        else
        {
            particle[i].next_no = i+1;
        }

        if (i%5 == 0)
        {
            particle[i].radius = 0.3;
        }
        else
        {
            particle[i].radius = 0.2;
        }

        // (-5.0, 5.0, 0)ϓɔzu
        particle[i].pos[0] = (double)i*1.0-5.0; 
        particle[i].pos[1] = 5.0; 
        particle[i].pos[2] = 0;
        for (int j=0; j<3; j++)
        {
            particle[i].oldPos[j] = particle[i].pos[j];
            particle[i].vel[j] = 0;
        }
    }

    // ̌vZ
    for (int i=0; i<PARTICLE_NUM; i++)
    {
        // 
        back = particle[i].back_no;
        if (back < 0)
        {
            particle[i].back_distance = 0;
        }
        else
        {
            for (int j=0; j<3; j++)
            {
                distance[j] = particle[back].pos[j] - particle[i].pos[j];
            }
            particle[i].back_distance = sqrt(distance[0]*distance[0]+distance[1]*distance[1]+distance[2]*distance[2]);
//            printf("back_distance%d=%f\n", i, particle[i].back_distance);
        }
        // E
        next = particle[i].next_no;
        if (next < 0)
        {
            particle[i].next_distance = 0;
        }
        else
        {
            for (int j=0; j<3; j++)
            {
                distance[j] = particle[next].pos[j] - particle[i].pos[j];
            }
            particle[i].next_distance = sqrt(distance[0]*distance[0]+distance[1]*distance[1]+distance[2]*distance[2]);
//            printf("next_distance%d=%f\n", i, particle[i].next_distance);
        }
    }
//    getchar();
}

// Œ_̐ݒ
void constantPosition()
{
    // Particle[0]͕ǂɌŒ
    for (int i=0; i<3; i++)
    {
        particle[0].pos[i] = particle[0].oldPos[i];
        particle[0].vel[i] = 0;
    }

    // }EXhbÕp[eBN̓}EXWɌŒ
    if (onButton[0] && selectNo > 0)
    {
        for (int i=0; i<3; i++)
        {
            particle[selectNo].pos[i] = nowPos[i];
            particle[selectNo].oldPos[i] = nowPos[i];
            particle[selectNo].vel[i] = 0;
        }
    }
}

void calculateConstraint(int startNo, int direction)
{
    double distance[3], length, dLength;
    btVector3 normalVec;
    int next, back, now;

    // Ƃ̏Փ˂̐vZ
    for (int i=0; i<PARTICLE_NUM; i++)
    {
        if (particle[i].pos[1] < (floorY+particle[i].radius))
        {
            particle[i].pos[1] = floorY+particle[i].radius;
        }
    }

    // 
    if (direction == 0)
    {
        now = startNo;
        back = particle[now].back_no;
        while(back >= 0)
        {
            // p[eBNԂ̋vZ
            for (int j=0; j<3; j++)
            {
                distance[j] = particle[back].pos[j] - particle[now].pos[j];
            }
            normalVec.setValue(distance[0], distance[1], distance[2]);
            length = sqrt(distance[0]*distance[0]+distance[1]*distance[1]+distance[2]*distance[2]);
//            printf("distance=%f\n", length);
            normalVec.normalize();
            // Ƃ̍vZ
            dLength = particle[now].back_distance - length;
//            printf("dLength=%f\n", dLength);
            // ̒ɂȂ悤ɗ̃p[eBN𔼕߂Â
            particle[now].pos[0] -= 0.5*dLength*normalVec.x();
            particle[now].pos[1] -= 0.5*dLength*normalVec.y();
            particle[now].pos[2] -= 0.5*dLength*normalVec.z();
            particle[back].pos[0] += 0.5*dLength*normalVec.x();
            particle[back].pos[1] += 0.5*dLength*normalVec.y();
            particle[back].pos[2] += 0.5*dLength*normalVec.z();
            now = back;
            back = particle[now].back_no;
        }
    }
    // E
    else
    {
        now = startNo;
        next = particle[now].next_no;
        while(next >= 0)
        {
            // p[eBNԂ̋vZ
            for (int j=0; j<3; j++)
            {
                distance[j] = particle[next].pos[j] - particle[now].pos[j];
            }
            normalVec.setValue(distance[0], distance[1], distance[2]);
            length = sqrt(distance[0]*distance[0]+distance[1]*distance[1]+distance[2]*distance[2]);
//            printf("distance=%f\n", length);
            normalVec.normalize();
            // Ƃ̍vZ
            dLength = particle[now].next_distance - length;
//            printf("dLength=%f\n", dLength);
            // ̒ɂȂ悤ɗ̃p[eBN𔼕߂Â
            particle[now].pos[0] -= 0.5*dLength*normalVec.x();
            particle[now].pos[1] -= 0.5*dLength*normalVec.y();
            particle[now].pos[2] -= 0.5*dLength*normalVec.z();
            particle[next].pos[0] += 0.5*dLength*normalVec.x();
            particle[next].pos[1] += 0.5*dLength*normalVec.y();
            particle[next].pos[2] += 0.5*dLength*normalVec.z();
            now = next;
            next = particle[now].next_no;
        }
    }

    // Œ_̏C
    constantPosition();
}

void update(double dt, int repeat)
{
    // xʒuXV
    for (int i=0; i<PARTICLE_NUM; i++)
    {
        for (int j=0; j<3; j++)
        {
            particle[i].pos[j] += particle[j].vel[j]*dt;
            // d
            if (j == 1)
            {
                particle[i].pos[j] += -9.8*dt;
            }
        }
    }

    constantPosition();

    // vZ
    for (int k=0; k<repeat; k++)
    {
        // {^Ăꍇ͂ɌvZ
        if (onButton[0])
        {
            // 
            calculateConstraint(selectNo, 1);
            // E
            calculateConstraint(selectNo, 0);
        }
        else
        {
            // 
            calculateConstraint(0, 1);
            // E
            calculateConstraint(PARTICLE_NUM-1, 0);
        }
    }

    // x̌vZƍXV
    for (int i=0; i<PARTICLE_NUM; i++)
    {
        // Öʒuƍ̈ʒu̍x
        for (int j=0; j<3; j++)
        {
            particle[i].vel[j] = (particle[i].pos[j] - particle[i].oldPos[j])/dt;
        }

        // ÖʒuXV
        for (int j=0; j<3; j++)
        {
            particle[i].oldPos[j] = particle[i].pos[j];
            // NbNʒup
            vertexPos[i][j] = particle[i].pos[j];
        }
    }
}

// `֐
void display(void)
{
    // wȉA_ʒu̐ݒ
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();
    gluLookAt(mv.eye[0], mv.eye[1], mv.eye[2], mv.center[0], mv.center[1], mv.center[2], mv.up[0], mv.up[1], mv.up[2]);

    update(0.017, 20);

    // p[eBN̕`
    glColor3f(1.0, 0, 0);
    for (int i=0; i<PARTICLE_NUM; i++)
    {
        glPushMatrix();
        glTranslatef(particle[i].pos[0], particle[i].pos[1], particle[i].pos[2]);
        glutSolidSphere(particle[i].radius, 16, 16);
        glPopMatrix();
    }

    // N̕`
    glLineWidth(5);
    glColor3f(0.0, 0.0, 1.0);
    for (int i=0; i<PARTICLE_NUM; i++)
    {
        int next = particle[i].next_no;
        if (next >= 0)
        {
            glBegin(GL_LINES);
            glVertex3f(particle[i].pos[0], particle[i].pos[1], particle[i].pos[2]);
            glVertex3f(particle[next].pos[0], particle[next].pos[1], particle[next].pos[2]);
            glEnd();
        }
    }

    // 
    glColor3f(0.7, 0.7, 0.7);
    glPushMatrix();
    glTranslatef(0, -25.0+floorY, 0);
    glutSolidCube(50.0f);
    glPopMatrix();

    // obt@̌
    glutSwapBuffers();
}

// 邱ƂȂꍇ͍ĕ`
void idle(void)
{
    glutPostRedisplay();
}

void motion(int x, int y)
{
    if (onButton[0] && selectNo > 0)
    {
        GLfloat dir[3], length;
        btVector3 tempDir;
        // }EX3Wi߃Nbvʏj
        mv.calculatePoint(x, y, startPos);
        for (int i=0; i<3; i++)
        {
            oldPos[i] = startPos[i];
            // NbNW|JWC̕xNg
            tempDir[i] = startPos[i] - mv.eye[i];
        }
        tempDir.normalize();
        for (int i=0; i<3; i++)
        {
            dir[i] = tempDir[i];
        }
        if (fabs(dir[2]) > 0.001)
        {
            // Z0ɂȂʒuvZ
            length = (0 - mv.eye[2])/dir[2];
        }
        else
        {
            length = 1.0f;
        }

        for (int i=0; i<3; i++)
        {
            nowPos[i] = mv.eye[i]+length*dir[i];
        }
    }
    mv.motion(x, y);
}

// }EXNbN̓
void mouse(int button, int state, int x, int y)
{
    int index = -1, id = -1;
    double dir[3];
    btVector3 tempDir;

    switch(button) 
    {
    case GLUT_LEFT_BUTTON:
        if (state == GLUT_DOWN) 
        {
            onButton[0] = TRUE;
            // NbNWi߃Nbvʏj
            mv.calculatePoint(x, y, startPos);
            for (int i=0; i<3; i++)
            {
                oldPos[i] = startPos[i];
                // NbNW|JWC̕xNg
                tempDir[i] = startPos[i] - mv.eye[i];
            }
            tempDir.normalize();
            for (int i=0; i<3; i++)
            {
                dir[i] = tempDir[i];
            }
            index = mv.rayNearestPoint(startPos, dir, vertexPos, PARTICLE_NUM, mv.zFar);
            selectNo = index;
            if (selectNo >= 0)
            {
                printf("nearestIndex=%d\n", index);
            }
            motion(x, y);
        }
        else
        {
            onButton[0] = FALSE;
        }
        break;
    case GLUT_MIDDLE_BUTTON:
        if (state == GLUT_DOWN) 
        {
            onButton[1] = TRUE;
        }
        else 
        {
            onButton[1] = FALSE;
        }
        break;
    case GLUT_RIGHT_BUTTON:
        if (state == GLUT_DOWN)
        {
            onButton[2] = TRUE;

        }
        else
        {
            onButton[2] = FALSE;
        }
    }

    mv.mouse(button, state, x, y);
}

// TCYύXp֐
void myReshape(int w, int h)
{
    windowWidth = w;
    windowHeight = h;
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(fovy, (GLfloat)w/(GLfloat)h, zNear, zFar);
    glMatrixMode(GL_MODELVIEW);

    mv.setPerspective(fovy, (GLfloat)w/(GLfloat)h, zNear, zFar);
    mv.setViewport(0, 0, w, h);
}

// I
void release()
{
    // 
    if (vertexPos != NULL)
    {
        for (int i=0; i<PARTICLE_NUM; i++)
        {
            delete [] vertexPos[i];
        }
        delete [] vertexPos;
        vertexPos = NULL;
    }
}

// 
void myinit(void)
{
    // x
    release();
    // ̌vZ
    compute();
    // ep[^ݒ
    glEnable(GL_DEPTH_TEST);
    glDisable(GL_LIGHTING);

    // }EXNbNWp
    if (vertexPos == NULL)
    {
        vertexPos = new GLfloat*[PARTICLE_NUM];
        for (int i=0; i<PARTICLE_NUM; i++)
        {
            vertexPos[i] = new GLfloat[3];
        }
    }
    for (int i=0; i<PARTICLE_NUM; i++)
    {
        for (int j=0; j<3; j++)
        {
            vertexPos[i][j] = particle[i].pos[j];
        }
    }
}


void keyboard(unsigned char key, int x, int y)
{
    switch(key) 
    {
    case 'q':
        // Exit
        exit(0);
        break;
    case 'i':
        // 
        myinit();
        break;
    default:
        break;
    }
    // ĕ`
    glutPostRedisplay();
}

int _tmain(int argc, _TCHAR* argv[])
{
    glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
    glutInitWindowPosition(200, 200);
    glutInitWindowSize(640, 480);
    glutCreateWindow(TitleString);
    myinit();
    glutReshapeFunc(myReshape);
    glutDisplayFunc(display);
    glutMouseFunc(mouse);
    glutMotionFunc(motion);
    glutKeyboardFunc(keyboard);
    glutIdleFunc(idle);
    atexit(release);
    glutMainLoop( );

    return 0;
}

